{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Warteschlangen\n",
    "\n",
    "Warteschlangen (engl. *Queue*) arbeiten nach dem **FIFO-Prinzip (First In, First Out)**, d.h. \n",
    "wer zuerst kommt, wird zuerst bedient. Konkret bedeutet das, dass ein neues Element\n",
    "*hinten* an die Warteschlange angehängt werden (mit der Operation `queue()`) und Elemente *vorne* aus der \n",
    "Warteschlange entnommen werden (mit der Operation `dequeue()`).\n",
    "\n",
    "```{figure} bilder/kd_queue_fosa.svg\n",
    "---\n",
    "width: 80%\n",
    "name: fig_kd_queue_fosa\n",
    "align: center\n",
    "---\n",
    "Klassendiagramm für den Datentyp *Warteschlange (Queue)* (FoSa 5.3)\n",
    "```\n",
    "\n",
    "**Aufgabe:**\n",
    "Nimm den folgenden Code als Vorlage und baue daraus die Klasse `Warteschlange`,\n",
    "entsprechend dem UML-Diagramm aus {numref}`fig_kd_queue_fosa`.\n",
    "\n",
    "`````{hint}\n",
    "- Du brauchst ein zusätzliches Attribut. Das Klassendiagramm zeigt dir, welches!\n",
    "- Ändere auch die Methodennamen und Kommentare.\n",
    "`````\n",
    "\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Tests für Warteschlange\n"
     ]
    },
    {
     "ename": "NameError",
     "evalue": "name 'Warteschlange' is not defined",
     "output_type": "error",
     "traceback": [
      "\u001b[0;31m---------------------------------------------------------------------------\u001b[0m",
      "\u001b[0;31mNameError\u001b[0m                                 Traceback (most recent call last)",
      "Cell \u001b[0;32mIn[1], line 46\u001b[0m\n\u001b[1;32m     44\u001b[0m \u001b[38;5;66;03m# Test\u001b[39;00m\n\u001b[1;32m     45\u001b[0m \u001b[38;5;28mprint\u001b[39m(\u001b[38;5;124m\"\u001b[39m\u001b[38;5;124mTests für Warteschlange\u001b[39m\u001b[38;5;124m\"\u001b[39m)\n\u001b[0;32m---> 46\u001b[0m q \u001b[38;5;241m=\u001b[39m \u001b[43mWarteschlange\u001b[49m()\n\u001b[1;32m     47\u001b[0m \u001b[38;5;28mprint\u001b[39m(\u001b[38;5;124m\"\u001b[39m\u001b[38;5;124mLeere Warteschlange ist leer:\u001b[39m\u001b[38;5;124m\"\u001b[39m, q\u001b[38;5;241m.\u001b[39mist_leer())\n\u001b[1;32m     48\u001b[0m \u001b[38;5;28mprint\u001b[39m(\u001b[38;5;124m\"\u001b[39m\u001b[38;5;124mAnna, Berta und Cora stellen sich nacheinander an\u001b[39m\u001b[38;5;124m\"\u001b[39m)\n",
      "\u001b[0;31mNameError\u001b[0m: name 'Warteschlange' is not defined"
     ]
    }
   ],
   "source": [
    "# Nimm diese Klasse als Vorlage und baue sie in die Klasse Warteschlange um\n",
    "\n",
    "class Stapel:\n",
    "\n",
    "    class Knoten:\n",
    "        def __init__(self, inhalt, naechster=None):\n",
    "            self.inhalt = inhalt\n",
    "            self.naechster = naechster\n",
    "\n",
    "    def __init__(self):\n",
    "        self.anfang: Stapel.Knoten|None = None\n",
    "        self.hoehe = 0 \n",
    "\n",
    "    def push(self, daten):\n",
    "        \"\"\"legt ein neues Element auf den Stapel\"\"\"\n",
    "        neuer_knoten = Stapel.Knoten(daten, self.anfang) \n",
    "        self.anfang = neuer_knoten \n",
    "        self.hoehe += 1  \n",
    "\n",
    "    def pop(self):\n",
    "        \"\"\"entfernt das oberste Element vom Stapel und gibt es zurück\"\"\"\n",
    "        if self.anfang is None:\n",
    "            raise IndexError(\"Pop-Operation auf leerem Stapel nicht möglich\")\n",
    "        inhalt = self.anfang.inhalt  \n",
    "        self.anfang = self.anfang.naechster \n",
    "        self.hoehe -= 1 \n",
    "        return inhalt\n",
    "\n",
    "    def top(self):\n",
    "        \"\"\"gibt das oberste Element des Stapels zurück, ohne es zu entfernen\"\"\"\n",
    "        if self.anfang is None:\n",
    "            raise IndexError(\"Top-Operation auf leerem Stapel nicht möglich\")\n",
    "        return self.anfang.inhalt\n",
    "\n",
    "    def ist_leer(self):\n",
    "        \"\"\"gibt True zurück, wenn der Stapel leer ist, sonst False\"\"\"\n",
    "        return self.anfang is None \n",
    "    \n",
    "    def anzahl_elemente(self):\n",
    "        \"\"\"gibt die Anzahl der Elemente auf dem Stapel zurück\"\"\"\n",
    "        return self.hoehe \n",
    "\n",
    "# Test\n",
    "print(\"Tests für Warteschlange\")\n",
    "q = Warteschlange()\n",
    "print(\"Leere Warteschlange ist leer:\", q.ist_leer())\n",
    "print(\"Anna, Berta und Cora stellen sich nacheinander an\")\n",
    "q.enqueue(\"Anna\")\n",
    "q.enqueue(\"Berta\")\n",
    "q.enqueue(\"Cora\")\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())\n",
    "erste = q.dequeue()\n",
    "print(\"Die erste Kundin wird bedient:\", erste)\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())\n",
    "print(\"Die zweite Kundin wird bedient:\", q.dequeue())\n",
    "print(\"Dora stellt sich an\")\n",
    "q.enqueue(\"Dora\")\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())\n",
    "weitere = [\"Ella\", \"Frieda\", \"Greta\"]\n",
    "print(\"Weitere Kundinnen stellen sich an:\", weitere)\n",
    "for kundin in weitere:\n",
    "    q.enqueue(kundin)\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())\n",
    "print(\"Alle verbleibenden Kundinnen werden bedient:\")\n",
    "while not q.ist_leer():\n",
    "    print(q.dequeue())\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "**Lösung:**"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "tags": [
     "hide-cell"
    ]
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Tests für Warteschlange\n",
      "Leere Warteschlange ist leer: True\n",
      "Anna, Berta und Cora stellen sich nacheinander an\n",
      "Länge der Warteschlange: 3\n",
      "Die erste Kundin wird bedient: Anna\n",
      "Länge der Warteschlange: 2\n",
      "Die zweite Kundin wird bedient: Berta\n",
      "Dora stellt sich an\n",
      "Länge der Warteschlange: 2\n",
      "Weitere Kundinnen stellen sich an: ['Ella', 'Frieda', 'Greta']\n",
      "Länge der Warteschlange: 5\n",
      "Alle verbleibenden Kundinnen werden bedient:\n",
      "Cora\n",
      "Dora\n",
      "Ella\n",
      "Frieda\n",
      "Greta\n",
      "Länge der Warteschlange: 0\n"
     ]
    }
   ],
   "source": [
    "\n",
    "class Warteschlange:\n",
    "\n",
    "    class Knoten:\n",
    "        def __init__(self, inhalt, naechster=None):\n",
    "            self.inhalt = inhalt\n",
    "            self.naechster = naechster\n",
    "\n",
    "    def __init__(self):\n",
    "        self.kopf: Warteschlange.Knoten|None = None\n",
    "        self.ende: Warteschlange.Knoten|None = None\n",
    "        self.hoehe = 0 \n",
    "\n",
    "    def enqueue(self, daten):\n",
    "        \"\"\"fügt ein neues Element in die Warteschlange ein\"\"\"\n",
    "        neuer_knoten = Warteschlange.Knoten(daten, None) \n",
    "        if self.kopf is None:\n",
    "            self.kopf = neuer_knoten \n",
    "        else:\n",
    "            self.ende.naechster = neuer_knoten\n",
    "        self.ende = neuer_knoten\n",
    "        self.hoehe += 1\n",
    "\n",
    "    def dequeue(self):\n",
    "        \"\"\"entfernt das vorderste Element aus der Warteschlange und gibt es zurück\"\"\"\n",
    "        if self.kopf is None:\n",
    "            raise IndexError(\"Dequeue-Operation auf leerer Warteschlange nicht möglich\")\n",
    "        inhalt = self.kopf.inhalt\n",
    "        self.kopf = self.kopf.naechster\n",
    "        if self.kopf is None:\n",
    "            self.ende = None\n",
    "        self.hoehe -= 1\n",
    "        return inhalt\n",
    "\n",
    "    def ist_leer(self):\n",
    "        \"\"\"gibt True zurück, wenn die Warterschlange leer ist, sonst False\"\"\"\n",
    "        return self.kopf is None \n",
    "    \n",
    "    def anzahl_elemente(self):\n",
    "        \"\"\"gibt die Anzahl der Elemente in der Warteschlange zurück\"\"\"\n",
    "        return self.hoehe \n",
    "\n",
    "# Test\n",
    "print(\"Tests für Warteschlange\")\n",
    "q = Warteschlange()\n",
    "print(\"Leere Warteschlange ist leer:\", q.ist_leer())\n",
    "print(\"Anna, Berta und Cora stellen sich nacheinander an\")\n",
    "q.enqueue(\"Anna\")\n",
    "q.enqueue(\"Berta\")\n",
    "q.enqueue(\"Cora\")\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())\n",
    "erste = q.dequeue()\n",
    "print(\"Die erste Kundin wird bedient:\", erste)\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())\n",
    "print(\"Die zweite Kundin wird bedient:\", q.dequeue())\n",
    "print(\"Dora stellt sich an\")\n",
    "q.enqueue(\"Dora\")\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())\n",
    "weitere = [\"Ella\", \"Frieda\", \"Greta\"]\n",
    "print(\"Weitere Kundinnen stellen sich an:\", weitere)\n",
    "for kundin in weitere:\n",
    "    q.enqueue(kundin)\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())\n",
    "print(\"Alle verbleibenden Kundinnen werden bedient:\")\n",
    "while not q.ist_leer():\n",
    "    print(q.dequeue())\n",
    "print(\"Länge der Warteschlange:\", q.anzahl_elemente())"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "base",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.12.2"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
